%global momorel 4
%define KVER 2.6.17-13m

Summary: Header files for the Linux kernel for use by glibc
Name: glibc-kernheaders
Version: 3.0
Release: %{momorel}m
License: GPL
Group: Development/System
ExclusiveOS: Linux
Obsoletes: kernel-headers
Provides: kernel-headers = %{KVER}
Prereq: fileutils initscripts >= 8.31.1-6m

BuildRoot: %{_tmppath}/%{name}-%{version}-root

Source0: glibc-kernheaders-%{KVER}.tar.bz2
Patch0: glibc-kernheaders-3.0-auto_fs4-types.patch

%description
Kernel-headers includes the C header files that specify the interface
between the Linux kernel and userspace libraries and programs.  The
header files define structures and constants that are needed for
building most standard programs and are also needed for rebuilding the
glibc package


%prep
%setup -q -c

%patch0 -p1

%build

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
tar -cf -  usr | tar -xf - -C $RPM_BUILD_ROOT
pushd $RPM_BUILD_ROOT/usr/include
%define keepdirs asm-generic
%define asmdir asm-%{_target_cpu}

%ifarch %{ix86}
%define asmdir asm-i386
%endif
%ifarch x86_64
%define keepdirs asm-i386|asm-x86_64|asm-generic
%define asmdir asm-bix86
%endif
%ifarch ppc ppc64
%define asmdir asm-powerpc
%endif
%ifarch s390x
%define asmdir asm-s390
%endif
%ifarch sparc sparc64
%define asmdir asm-bisparc
%define keepdirs asm-sparc*|asm-generic
%endif

mv %{asmdir} asm
for DIR in asm-* ; do 
    case $DIR in
       %{keepdirs})
	    ;;
	*)
	    rm -rf $DIR
	    ;;
    esac
done
rm asm*/atomic.h
echo "#error asm/atomic.h is a kernel-private header. Even if your broken program compiled before, it was not likely to _work_." > asm/atomic.h

( echo "#ifdef I_AM_BROKEN_AND_I_KNOW_IT" 
  echo "#warning asm/io.h is a kernel-private header. Do not use it in userspace."
  echo "#else" 
  echo "#error asm/io.h is a kernel-private header. Do not use it in userspace."
  echo "#endif"
  cat asm/io.h ) > tmpfile

mv tmpfile asm/io.h
# glibc-headers provides /usr/include/scsi, although it's kernel headers
rm -rf scsi

popd

%clean
rm -rf $RPM_BUILD_ROOT


%pre
[ -L /usr/include/linux ] && rm -f /usr/include/linux || :
[ -L /usr/include/asm ] && rm -f /usr/include/asm || :
%ifarch sparc
[ -L /usr/include/asm-sparc ] && rm -f /usr/include/asm-sparc
[ -L /usr/include/asm-sparc64 ] && rm -f /usr/include/asm-sparc64
%endif
exit 0

%post
exit 0

###
### file lists
###

%files
%defattr(-,root,root)
/usr/include/*

%changelog
* Thu Aug 10 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (3.0-4m)
- add glibc-kernheaders-3.0-auto_fs4-types.patch

* Tue Aug  8 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (3.0-3m)
- rebuild

* Sat Jul 29 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (3.0-2m)
- modify linux/ethtool.h
- Provides: kernel-headers

* Sat Jul 29 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (3.0-1m)
- new kern-headers

* Sun Feb 12 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (2.6.12-1m)
- update to 2.6.12.0

* Thu Jan 20 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.6.10-1m)
- update to 2.6.10.0

* Mon Dec 20 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.6.9-3m)
- glob upper directory

* Wed Nov 03 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.6.9-2m)
- update to 2.6.9.1

* Mon Oct 25 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.6.9-1m)
- update to 2.6.9.0
- delete included Patch0: linux-libc-headers-2.6.8.1-ext3_fs.patch

* Fri Sep 10 2004 Shotaro Kamio <skamio@momonga-linux.org>
- (2.6.8-4m)
- exclude scsi dir

* Thu Sep  9 2004 Shotaro Kamio <skamio@momonga-linux.org>
- (2.6.8-3m)
- use _SUPPRESS_LLH_WARN_ in patch1

* Wed Sep  8 2004 Shotaro Kamio <skamio@momonga-linux.org>
- (2.6.8-2m)
- initscripts >= 7.55.1-5m (initscripts-7.55.1-4m is mistake.)

* Wed Sep  8 2004 Shotaro Kamio <skamio@momonga-linux.org>
- (2.6.8-1m)
- initial packaging
